<template>
    <div>
        {{numberRows}}
        {{numberCells}}
        <table>
          <tr v-for="(row, indexRow) in cellsValues" :key="indexRow">
            <td v-for="(cell, indexCell) in row"
            :key="indexCell"
            @click="$set(row, indexCell, !cell)"
            :class="cell ? 'selected' : ''">
            </td>
          </tr>
        </table>

    </div>
</template>

<script>
export default {
  name: 'PicrossEditor',
  props: {
    numberRows: Number,
    numberCells: Number
  },
  data: function () {
    return { cellsValues: [] }
  },
  created () {
    this.createCellsValuesArray()
  },
  computed: {
    nonogramData () {
      // parcours du tableau
      // création d'un objet mémoire recensant les cellules activées
      // on stocke à la fois par colonnes et par lignes
      const rowsData = []
      const columnsCellsData = []
      /**
   * Première étape,
   * on recense chaque cellule
   * dans deux tableaux distincts,
   * * l'un pour les lignes,
   * * l'autre pour les colonnes
   */
      this.cellsValues.forEach((currentRow, indexTableRow) => {
        const rowData = []
        let previousNumberCellsEnabled = 0
        currentRow.forEach((currentCell, indexTableColumn) => {
          if (currentCell === true) {
            previousNumberCellsEnabled++
          } else if (previousNumberCellsEnabled > 0) {
            rowData.push(previousNumberCellsEnabled)
            previousNumberCellsEnabled = 0
          }
          if (columnsCellsData.length === indexTableColumn) {
            columnsCellsData.push([])
          }
          columnsCellsData[indexTableColumn].push(currentCell)
        })
        if (previousNumberCellsEnabled > 0) {
          rowData.push(previousNumberCellsEnabled)
        }
        rowsData.push(rowData)
      })

      /**
   * Deuxième étape,
   * on calcule les enchaînements des colonnes
   */
      const columnsData = columnsCellsData.map(currentColumnCellData => {
        const columnData = []
        let previousNumberCellsEnabled = 0
        currentColumnCellData.forEach(currentCell => {
          if (currentCell) {
            previousNumberCellsEnabled++
          } else if (previousNumberCellsEnabled > 0) {
            columnData.push(previousNumberCellsEnabled)
            previousNumberCellsEnabled = 0
          }
        })
        if (previousNumberCellsEnabled > 0) {
          columnData.push(previousNumberCellsEnabled)
        }
        return columnData
      })

      return {
        data: {
          rows: rowsData,
          columns: columnsData
        },
        size: {
          rows: rowsData.length,
          columns: columnsData.length
        }
      }
    }

  },
  methods: {
    makeCellsValuesArray (numberRows, numberCells) {
      const cellsValues = []
      for (let i = 0; i < numberRows; i++) {
        const currentRowCellsValues = new Array(numberCells).fill(false)
        cellsValues.push(currentRowCellsValues)
      }
      this.cellsValues = cellsValues
    },
    createCellsValuesArray () {
      this.makeCellsValuesArray(this.numberRows, this.numberCells)
    },
    isCellSelected (rowRange, cellRange) {
      return this.cellsValues?.[rowRange - 2]?.[cellRange - 2]
    },
    toggleCell (rowRange, cellRange) {
      /**
       * ranges are from 1 and not 0 based
       * and we are creating a first row and first column for tips
       * so we exclude the first row, and first column,
       * so we only want range > 1, and they will match the 0 based cellsValues array
       * a row with the range n° 2 is in fact the row with index 0
       * same for cell, cell Range n° 2 is in fact the first cell
       */
      if (rowRange > 1 && cellRange > 1) {
        this.$set(
          this.cellsValues[rowRange - 2],
          cellRange - 2,
          !this.isCellSelected(rowRange, cellRange)
        )
      }
    }
  },

  watch: {
    cellsValues () {
      this.$emit('update-picross-data', this.nonogramData)
    },
    numberRows: 'createCellsValuesArray',
    numberCells: 'createCellsValuesArray'
  }
}

</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
table {
  border: 1px solid gray;
  border-collapse: collapse;
  font-family: monospace;
  text-align: right;
}
tr:nth-child(1) td {
  word-wrap: anywhere;
  white-space: pre-wrap;
  text-align: center;
  vertical-align: bottom;
  max-width: 20px;
}
tr, td {
  height: 20px;
}
td {
  min-width: 20px;
  width: 20px;
  border: 1px solid gray;
}
tr td:nth-child(1) {
  white-space: nowrap;
  width: auto;
  text-align: left;
}
td:hover {
  background-color: red;
}
td:nth-child(5n + 1) {
  border-right: 2px solid black;
}
tr:nth-child(5n + 1) {
  border-bottom: 2px solid black;
}
.selected {
  background-color: blue;
}
</style>
